﻿using System.Collections.Generic;
using System.Linq;
using Windows.Kinect;

namespace KinectModule
{
    public class RealBody : IBody
    {
        private Body _Body;

        public bool                          IsTracked
        {
            get
            {
                return _Body.IsTracked;
            }
        }
        public Dictionary<JointType, IJoint> Joints
        {
            get
            {
                return _Body.Joints.Select(x => new KeyValuePair<JointType, IJoint>
                                        (x.Key, new RealJoint(x.Value)))
                                   .ToDictionary(x => x.Key, x => x.Value);
            }
        }
        public Body                          Value
        {
            get
            {
                return _Body;
            }
        }

        public RealBody(Body body)
        {
            _Body = body;
        }

        public override bool Equals(object obj)
        {
            return this.Equals(obj as IBody);
        }

        public bool Equals(IBody obj)
        {
            var keys = Joints.Select(x => x.Key);
            foreach (var key in keys)
            {
                if (!Joints[key].Equals(obj.Joints[key]))
                    return false;
            }

            return IsTracked.Equals(obj.IsTracked);
        }

        public override int GetHashCode()
        {
            return 0;
        }
    }
}