﻿using System.Linq;
using Windows.Kinect;

namespace KinectModule
{
    public class RealBodyFrame : IBodyFrame
    {
        private Body[] _Buffer = new Body[KinectConstants.BodyCount];
        private bool IsValid   = false;

        public RealBodyFrame(BodyFrame frame)
        {
            if (frame != null)
            {
                frame.GetAndRefreshBodyData(_Buffer);

                IsValid = true;
            }
        }

        public void CopyData(IBody[] buffer)
        {
            if (IsValid)
                Enumerable.Range(0, KinectConstants.BodyCount)
                          .ToList()
                          .ForEach(x => buffer[x] = new RealBody(_Buffer[x]));
        }
    }
}