﻿using System;
using System.Runtime.InteropServices;
using Windows.Kinect;

namespace KinectModule
{
    public class RealBodyIndexFrame : IBodyIndexFrame
    {
        private byte[] _Buffer = new byte[KinectConstants.DepthWidth *
                                          KinectConstants.DepthHeight];
        private bool IsValid   = false;

        public RealBodyIndexFrame(BodyIndexFrame frame)
        {
            if (frame != null)
            {
                var BodyIndexData = GCHandle.Alloc(_Buffer, GCHandleType.Pinned);
                frame.CopyFrameDataToIntPtr(BodyIndexData.AddrOfPinnedObject(), (uint)_Buffer.Length);
                BodyIndexData.Free();

                IsValid = true;
            }
        }

        public void CopyData(byte[] buffer)
        {
            if (IsValid)
                Array.Copy(_Buffer, buffer, _Buffer.Length);
        }
    }
}