﻿using System;
using System.Runtime.InteropServices;
using Windows.Kinect;

namespace KinectModule
{
    public class RealColorFrame : IColorFrame
    {
        private byte[] _Buffer = new byte[KinectConstants.ColorWidth *
                                          KinectConstants.ColorHeight *
                                          KinectConstants.ColorCount];
        private bool IsValid   = false;

        public RealColorFrame(ColorFrame frame)
        {
            if (frame != null)
            {
                var ColorData = GCHandle.Alloc(_Buffer, GCHandleType.Pinned);
                frame.CopyConvertedFrameDataToIntPtr(ColorData.AddrOfPinnedObject(), (uint)_Buffer.Length, ColorImageFormat.Rgba);
                ColorData.Free();

                IsValid = true;
            }
        }

        public void CopyData(byte[] buffer)
        {
            if (IsValid)
                Array.Copy(_Buffer, buffer, _Buffer.Length);
        }
    }
}