﻿using System;
using System.Runtime.InteropServices;
using Windows.Kinect;

namespace KinectModule
{
    public class RealDepthFrame : IDepthFrame
    {
        private ushort[] _Buffer = new ushort[KinectConstants.DepthWidth *
                                              KinectConstants.DepthHeight];
        private bool     IsValid = false;

        public RealDepthFrame(DepthFrame frame)
        {
            if (frame != null)
            {
                var DepthData = GCHandle.Alloc(_Buffer, GCHandleType.Pinned);
                frame.CopyFrameDataToIntPtr(DepthData.AddrOfPinnedObject(), (uint)_Buffer.Length * sizeof(ushort));
                DepthData.Free();

                IsValid = true;
            }
        }

        public void CopyData(ushort[] buffer)
        {
            if (IsValid)
                Array.Copy(_Buffer, buffer, _Buffer.Length);
        }
    }
}