﻿namespace KinectModule
{
    public class SourceBuffer
    {
        private byte[]   _ColorBuffer     = new byte  [KinectConstants.ColorWidth *
                                                       KinectConstants.ColorHeight *
                                                       KinectConstants.ColorCount],
                         _BodyIndexBuffer = new byte  [KinectConstants.DepthWidth *
                                                       KinectConstants.DepthHeight];
        private ushort[] _DepthBuffer     = new ushort[KinectConstants.DepthWidth *
                                                       KinectConstants.DepthHeight];
        private IBody[]  _BodyBuffer      = new IBody [KinectConstants.BodyCount];

        public byte[] ColorBuffer
        {
            get
            {
                return _ColorBuffer;
            }
        }
        public byte[] BodyIndexBuffer
        {
            get
            {
                return _BodyIndexBuffer;
            }
        }
        public ushort[] DepthBuffer
        {
            get
            {
                return _DepthBuffer;
            }
        }
        public IBody[] BodyBuffer
        {
            get
            {
                return _BodyBuffer;
            }
        }

        public void UpdateBuffers(IMultiSourceFrame sourceFrame)
        {
            sourceFrame.LastColorFrame    .CopyData(_ColorBuffer);
            sourceFrame.LastBodyIndexFrame.CopyData(_BodyIndexBuffer);
            sourceFrame.LastDepthFrame    .CopyData(_DepthBuffer);
            sourceFrame.LastBodyFrame     .CopyData(_BodyBuffer);
        }
    }
}